/*
  Amigus Labs http://www.amiguslabs.org

  Boya estación meteorológica -servidor datos

  Created Luis Diaz-Faes 2022 • 26/5/2022
  
  Fab Academy
*/

#include <SPI.h>
#include <WiFiNINA.h>
#include "arduino_secrets.h"

#include <Wire.h>
int d1 = 0;

unsigned long timeout_pwm_micros = 50000;

///////please enter your sensitive data in the Secret tab/arduino_secrets.h
char ssid[] = SECRET_SSID;        // your network SSID (name)
char pass[] = SECRET_PASS;    // your network password (use for WPA, or use as key for WEP)
int keyIndex = 0;                // your network key Index number (needed only for WEP)

int led =  LED_BUILTIN;
int status = WL_IDLE_STATUS;
WiFiServer server(80);

unsigned long tiempo;
int temp;
int temp1;

void setup() {


  Serial.begin(9600);
  /*  while (!Serial) {
      ; // wait for serial port to connect. Needed for native USB port only
    }*/

  Serial.println("Access Point Web Server");

  pinMode(led, OUTPUT);      // set the LED pin mode

  // check for the WiFi module:
  if (WiFi.status() == WL_NO_MODULE) {
    Serial.println("Communication with WiFi module failed!");
    // don't continue
    while (true);
  }

  String fv = WiFi.firmwareVersion();
  if (fv < WIFI_FIRMWARE_LATEST_VERSION) {
    Serial.println("Please upgrade the firmware");
  }

  // by default the local IP address of will be 192.168.4.1
  // you can override it with the following:
   // WiFi.config(IPAddress(10, 0, 0, 1));

  // print the network name (SSID);
  Serial.print("Creating access point named: ");
  Serial.println(ssid);

  // Create open network. Change this line if you want to create an WEP network:
  status = WiFi.beginAP(ssid, pass);
  if (status != WL_AP_LISTENING) {
    Serial.println("Creating access point failed");
    // don't continue
    while (true);
  }

  // wait 10 seconds for connection:
  delay(10000);

  // start the web server on port 80
  server.begin();

  // you're connected now, so print out the status
  printWiFiStatus();


  Wire.begin(8);     //change address
  Wire.onReceive(recieveEvent);


}


void loop() {
  // compare the previous status to the current status
  if (status != WiFi.status()) {
    // it has changed update the variable
    status = WiFi.status();

    if (status == WL_AP_CONNECTED) {
      // a device has connected to the AP
      Serial.println("Device connected to AP");
    } else {
      // a device has disconnected from the AP, and we are back in listening mode
      Serial.println("Device disconnected from AP");
    }
  }
  tiempo = millis();

  // lectura I2C

 // Serial.println(temp);

  WiFiClient client = server.available();   // listen for incoming clients

  if (client) {                             // if you get a client,
    Serial.println("new client");           // print a message out the serial port
    String currentLine = "";                // make a String to hold incoming data from the client
    while (client.connected()) {            // loop while the client's connected
      if (client.available()) {             // if there's bytes to read from the client,
        char c = client.read();             // read a byte, then
        Serial.write(c);                    // print it out the serial monitor
        if (c == '\n') {                    // if the byte is a newline character

          // if the current line is blank, you got two newline characters in a row.
          // that's the end of the client HTTP request, so send a response:
          if (currentLine.length() == 0) {
            // HTTP headers always start with a response code (e.g. HTTP/1.1 200 OK)
            // and a content-type so the client knows what's coming, then a blank line:

          }
          else {      // if you got a newline, then clear currentLine:
            currentLine = "";
          }
        }
        else if (c != '\r') {    // if you got anything else but a carriage return character,
          currentLine += c;      // add it to the end of the currentLine
        }

        // Check to see if the client request was "GET /H" or "GET /L":

        if (currentLine.endsWith("GET /datos")) {
          client.println("HTTP/1.1 200 OK");
          client.println("Content-type:text/html");
          client.println();


          // Convertir valor a entero de 3 cifras
          temp1 = round(temp * 10);

          // the content of the HTTP response follows the header:
          if (temp1 < 100) {
            client.print("0");
          }
          if (temp1 < 10) {
            client.print("0");
          }
          client.print(temp1);
          client.print(":");




          // The HTTP response ends with another blank line:
          client.println();
          // break out of the while loop:
          break;            // GET /H turns the LED on
        }


        if (currentLine.endsWith("GET /temp")) {
          client.println("HTTP/1.1 200 OK");
          client.println("Content-type:text/html");
          client.println();

          // the content of the HTTP response follows the header:

          client.print(temp);

          // The HTTP response ends with another blank line:
          client.println();
          // break out of the while loop:
          break;            // GET /H turns the LED on
        }

        
      }
    }
    // close the connection:
    client.stop();
    Serial.println();
    Serial.println("client disconnected");
  }

}


void recieveEvent(int howMany)
{
  while (Wire.available())
  {
  temp= Wire.read();
  temp1= Wire.read();
      Serial.println(temp);
      Serial.println(temp1);
  }
}


void printWiFiStatus() {
  // print the SSID of the network you're attached to:
  Serial.print("SSID: ");
  Serial.println(WiFi.SSID());

  // print your WiFi shield's IP address:
  IPAddress ip = WiFi.localIP();
  Serial.print("IP Address: ");
  Serial.println(ip);

  // print where to go in a browser:
  Serial.print("To see this page in action, open a browser to http://");
  Serial.println(ip);

}
